# -*- coding: utf-8 -*-
"""
Created on Wed Jul 11 09:40:36 2018

"""
from math import *
from cmath import phase
import numpy as np
import matplotlib.pyplot as plt
from filtres import *
from signaux import *

#==============================================================================
# Paramètre d'entrée du programme
#==============================================================================
f=100 #Fréquence du fondamental du signal d'entrée en Hz

def e(t):
    return creneau(t,1,f)

filtre=passebas_2 #Nom du filtre, dans le module filtres
fc=10 #Fréquence de coupure en Hz
Q=0.1 #Facteur de qualité (le cas échéant)
A=1 #Gain dans la BP (le cas échéant)

graphe=1 #Affichage du graphe (4 périodes)
spectre=1 #Affichage du spectre, entrée et sortie


#==============================================================================
# Signal d'entrée décomposé en série de Fourier
#==============================================================================
nper=100 #nombres de périodes
nppp=100 #Points par période
ntot=nppp*nper
tabt=np.linspace(0,nper/f,ntot) #100 périodes, 100 points par périodes
tabe=np.array([e(t) for t in tabt])
liste_f=np.linspace(0,f*nper/2,int(ntot/2+1)) #Liste des fréquences
fouriere=np.fft.rfft(tabe)
fouriere[0]/=2 #la composante continue est deux fois trop élevée par symétrie
fouriere_norm=fouriere/(ntot/2)#Amplitude normalisée


    
#==============================================================================
# Filtrage dans le domaine fréquenciel et création du signal de sortie par synthèse de Fourier
#==============================================================================
pas_freq=liste_f[1]-liste_f[0] #pas en frequence
fouriers=np.empty(len(fouriere),dtype="complex")
for i,freq in enumerate(liste_f): #Pour chaque fréquence
    if filtre==passebas_1 or filtre==passehaut_1:
        H=filtre(freq,fc,A)
    elif filtre==passebas_2 or filtre==passehaut_2 or filtre==passebande_2 or filtre==coupebande_2:
        H=filtre(freq,fc,Q,A)
    fouriers[i]=fouriere_norm[i]*H
    
def s(t,filtre):
    res=fouriers[0]
    for i in range(1,len(liste_f)):
        res+=abs(fouriers[i])*cos(2*np.pi*liste_f[i]*t+phase(fouriers[i]))
    return res

#==============================================================================
# Affichage du graphe temporel       
#==============================================================================
    
if graphe:
    tabt=np.linspace(0,4/f,500) #Nombre de points crucial pour la rapidité du programme, attention
    tabe=[e(t) for t in tabt]
    tabs=[s(t,filtre) for t in tabt]
    plt.plot(tabt,tabe)
    plt.plot(tabt,tabs,"r")
    plt.xlabel("$t$ en secondes")
    plt.legend(("$e(t)$","$s(t)$"))
    plt.grid()
    plt.show()
    
#==============================================================================
# Affichage du spectre en amplitude
#==============================================================================

if spectre:
    plt.subplot(121)
    plt.xlim(0,10*f)
    plt.plot(liste_f,abs(fouriere_norm))
    plt.xlabel("$f$ en Hz")
    plt.ylabel("Amplitude")
    plt.title("Spectre de e(t)")
    plt.subplot(122)
    plt.plot(liste_f,abs(fouriers))
    plt.xlim(0,10*f)
    plt.xlabel("$f$ en Hz")
    plt.title("Spectre de s(t)")
    plt.show()
        